300. 最长上升子序列

Posted thefatcat

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了300. 最长上升子序列相关的知识,希望对你有一定的参考价值。

题目描述:

给定一个无序的整数数组,找到其中最长上升子序列的长度。

示例:

输入: [10,9,2,5,3,7,101,18]
输出: 4
解释: 最长的上升子序列是 [2,3,7,101],它的长度是 4。
说明:

可能会有多种最长上升子序列的组合,你只需要输出对应的长度即可。
你算法的时间复杂度应该为 O(n2) 。
进阶: 你能将算法的时间复杂度降低到 O(n log n) 吗?

 

 

思想:动态规划

定义 dp[i] 为考虑前 i 个元素,以第 i 个数字结尾的最长上升子序列的长度,注意 nums[i] 必须被选取。

我们从小到大计算 dp[] 数组的值,在计算 dp[i] 之前,我们已经计算出 dp[0…i−1] 的值,则状态转移方程为:

dp[i]=max(dp[j])+1,其中0≤j<i且num[j]<num[i]

即考虑往 dp[0…i−1] 中最长的上升子序列后面再加一个nums[i]。由于 dp[j] 代表 nums[0…j] 中以nums[j] 结尾的最长上升子序列,所以如果能从 dp[j] 这个状态转移过来,那么 nums[i] 必然要大于 nums[j],才能将 nums[i] 放在nums[j] 后面以形成更长的上升子序列。

最后,整个数组的最长上升子序列即所有 dp[i] 中的最大值。

LIS = max(dp[i])  其中 0<= i < n

 

代码:

class Solution {
public:
    int lengthOfLIS(vector<int>& nums) {
        if(nums.size() == 0)
            return 0;
        int n = nums.size();
        vector<int> dp(n,1);
        for(int i=1;i<n;i++){
            for(int j=0;j<i;j++){
                if(nums[i] > nums[j])
                    dp[i] = max(dp[i],dp[j] + 1);
            }
        }
        return *max_element(dp.begin(),dp.end());
    }
};

注:

C++中对vector求最大值:使用迭代器和algorithm库中的max_element函数来求得vector中的最大值,顺便求出了最大值所在的位置。

示例:

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main(){
    vector<int> a = { 2,4,6,7,1,0,8,9,6,3,2 };
    auto maxPosition = max_element(a.begin(), a.end());
    cout << *maxPosition << " at the postion of " << maxPosition - a.begin() <<endl;
    //cout << a[maxPosition - a.begin()] << " at the postion of " << distance(a.begin(), maxPosition) << endl;
    system("pause");
    return 0;
}

 

以上是关于300. 最长上升子序列的主要内容,如果未能解决你的问题,请参考以下文章

leetcode300 最长上升子序列(Medium)

Leetcode 300.最长上升子序列

300. 最长上升子序列

300. 最长上升子序列

300. 最长上升子序列

Leetcode-300. 最长上升子序列